----------------------------------------------------------------------------------------------------------
------------------------------------------------MageGateLT------------------------------------------------
----------------------------------------------------------------------------------------------------------
-- Written by: Endar_Ren																				--
----------------------------------------------------------------------------------------------------------
----------------------------------------------Change History----------------------------------------------
----------------------------------------------------------------------------------------------------------
-- Version 1.1 Changes 8/25/2010																		--
-- *  Fixed use of addon when a target or a group member is casting a portal.							--
-- *  Corrected GateGroup function so that the Party channel is used outside of an instance.			--
-- *  Corrected spelling error:  "Dailing".																--
--======================================================================================================--							
-- Version 1.2 Changes 10/5/10																			--
-- *  Fixed the nothing happening in Party group type. (I think)										--
--======================================================================================================--
-- Version 1.3 Changes 10/13/2010																		--
-- *  Now usable in 4.0.1.																				--
--======================================================================================================--
-- Version 1.4 Changes 11/3/2010																		--
-- *  Add in Slash Command to turn the addon on and off. (Does not disable or enable the addon)			--
--======================================================================================================--
-- Version 1.4.1 Changes 11/18/2010																		--
-- *  Added Confirm Summons event and "Incoming traveller" message.  Need to test.	FAILED				--
-- *  Changed GateGroup to use number in the party to see if you are alone.	Need to test.  FAILED		--
-- *  Added version number field.																		--
--======================================================================================================--
-- Version 1.4.2  Changed 1/3/2011
-- * Adding in sound effects.  Sounds given to me by Ricardo58.  Thank you.
--======================================================================================================--
-- Version 1.4.3 Changed 4/26/2011
-- * TOC version number changed to 40100.
----------------------------------------------------------------------------------------------------------

local frame = CreateFrame("Frame", nil, UIParent);
local MG_VERSION = 10403;
SLASH_MAGEGATE1 = '/mgate';
SlashCmdList["MAGEGATE"] = handler;

--PlaySoundFile (file path)
--Slash Command handler.
local function handler(msg, editbox)

	if msg == 'on' then

		GATEON = true;
		print("Mage Gate is set on.");
	else
		if msg == 'off' then
			GATEON = false;
			print("Mage Gate is set off.");
		else
			if msg == 'mute' then
				if SOUNDFX == false then
					SOUNDFX = true
					print("Mage Gate is unmuted.");
				else
					SOUNDFX = false
					print("Mage Gate is muted.");
				end
			end
		end
	end
end



channeling =false;

--This function is used to determine which kind of group,
--if any, the player is in.  It returns the channel name
--needed to reach all the players in that group.
--The return value is a String.

function GateGroup ()

	if GetNumPartyMembers()>0 then
		if (UnitInParty("player") ~= nil) then
			if (UnitInRaid("player") ~= nil) then
				return "RAID"
			end
			return "PARTY"
		end
	else
		if (UnitInRaid("player") ~= nil) then
				return "RAID"
		else
			return "SAY"
		end
	end


--	if (UnitInParty("player") ~= nil) then
--		if (UnitInRaid("player") ~= nil) then
--			return "RAID"
--		end
--		return "PARTY"
--	end
--	return "SAY"
end

function GateEvent (self, event, unitID,spell,...)

	if (event == "ADDON_LOADED") then
		if (unitID =="MageGate" or unitID =="Mage Gate") then
			if GATEON == nil then
				GATEON = true;
			end
			if SOUNDFX == nil then
				SOUNDFX = true
			end
		--print ("Mage Gate loaded.  Version "..MG_VERSION);
		end
		
	end
	if event == "CONFIRM_SUMMON" and GATEON == true then
			--Special thanks to Garshaw for this idea.
				if unitID == "player" then
					local chann = GateGroup();
					SendChatMessage("Incoming traveller!", chann);
				end
	end
	if (channeling == false) then
		if (event == "UNIT_SPELLCAST_START" and GATEON == true) then

			
			local beg, last = string.find(spell,"Portal: ");

			if (beg~=nil) then
				if (unitID == "player") then
					local chann = GateGroup();
					channeling = true;
					SendChatMessage("Dialing ".. string.sub(spell,last+1) ..".", chann);

				end
				
			end

		end

	
	elseif (channeling == true) then

		if (event == "UNIT_SPELLCAST_SUCCEEDED" and GATEON == true) then

	
			local beg, last = string.find(spell,"Portal: ");
			if (beg~=nil) then
				if (unitID == "player") then
					local chann = GateGroup();
					channeling = false;
					SendChatMessage("Chevron 7 locked!", chann);

				end
				if SOUNDFX then
					PlaySoundFile("Interface\\AddOns\\MageGate\\Sound Files\\Kawoosh 1.ogg")
				end
			end

	
		elseif (event == "UNIT_SPELLCAST_FAILED_QUIET" and GATEON == true) then


		
			local beg, last = string.find(spell,"Portal: ");
			if (beg~=nil) then
				if (unitID == "player") then
					local chann = GateGroup();
					channeling = false;
					SendChatMessage("Dialing sequence aborted!", chann);

				end
				if SOUNDFX then
					PlaySoundFile("Interface\\AddOns\\MageGate\\Sound Files\\SG-1 Dial Abort.ogg")
				end
			end
		

	
		elseif (event == "UNIT_SPELLCAST_INTERRUPTED" and GATEON == true) then


			local beg, last = string.find(spell,"Portal: ");
			if (beg~=nil) then
				if (unitID == "player") then
					local chann = GateGroup();
					channeling = false;
					SendChatMessage("Dialing sequence aborted!", chann);

				end
				if SOUNDFX then
					PlaySoundFile("Interface\\AddOns\\MageGate\\Sound Files\\SG-1 Dial Abort.ogg")
				end
			end
		
			

			end
		end
	end



--Event Register--
frame:SetScript("OnEvent", GateEvent)
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("UNIT_SPELLCAST_START")
frame:RegisterEvent("UNIT_SPELLCAST_STOP")
frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
frame:RegisterEvent("UNIT_SPELLCAST_FAILED_QUIET")
frame:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED") 
frame:RegisterEvent("CONFIRM_SUMMON")